/************************************************************************
	ds1302.h

    16x8 LED Display
    Copyright (C) 2009 Simon Inns

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Email: simon.inns@gmail.com

************************************************************************/

#ifndef _DS1302_H_
#define _DS1302_H_

// DS1302 Commands (all WRITE, add 1 for READ)
#define	SECONDS	0x80
#define MINUTES	0x82
#define HOURS	0x84
#define DATE	0x86
#define MONTH	0x88
#define	DAY		0x8A
#define YEAR	0x8C

// WP = Write Protect
#define WP		0x8E

// TCS = Trickle Charge Set
#define TCS		0x90

#define CLOCK_BURST 0xBE
#define RAM_BURST	0xFE

#define RTC_READ	1
#define RTC_WRITE	0

// function prototypes
void sendByteRTC(unsigned char byte);
unsigned char receiveByteRTC(void);
void initRTC(void);
void setRTC(void);
void readRTC(void);

void timeString(char *string);
void dateString(char *string);

#endif