/************************************************************************
	hardware.h

    16x8 LED Display
    Copyright (C) 2009 Simon Inns

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Email: simon.inns@gmail.com

************************************************************************/

#ifndef _HARDWARE_H_
#define _HARDWARE_H_

// Fosc frequency (48 Mhz)
#define _XTAL_FREQ 48000000

#define CS_LED	RB2
#define CS_164	RB3
#define OE_LED	RB4

#define ON 	1
#define OFF	0

#define	WRITE	0
#define READ	1

#define FALSE	0
#define TRUE	1

// LED matrix row control lines
#define ROW_7	RA1
#define ROW_6	RA2
#define ROW_5	RA3
#define ROW_4	RA4
#define ROW_3	RA5
#define ROW_2	RC0
#define ROW_1	RC1
#define ROW_0	RC2

// Define a global structure for holding the display state;
struct displayRow {
	unsigned char byte1;
	unsigned char byte2;
};

struct displayState {
	struct displayRow row[8];
	unsigned char currentRow;
} display;

// Definitions for the DS1302 Real-time clock
#define	RTC_SCLK	RC0
#define RTC_IO		RC1
#define RTC_CE		RC2

// IO PIN TRIS
#define RTC_IO_TRIS	TRISC1

// Define a global structure for passing the time/date
struct datetimeStruct {
	unsigned char hours;	// 0-23
	unsigned char minutes;	// 0-59
	unsigned char seconds;	// 0-59

	unsigned char year;		// 0-99
	unsigned char month;	// 1-12
	unsigned char day;		// 1-31
	
	unsigned char dayNo;	// 1-7

	unsigned char wp;		// Write protect bit
} datetime;

// Push buttons (active low)
#define UP_BUTTON		RC4
#define DOWN_BUTTON		RC5
#define	ENTER_BUTTON	RC6

// LM35 Temperature sensor
#define LM35	RA0

#endif