/************************************************************************
	interrupt.c

    16x8 LED Display
    Copyright (C) 2009 Simon Inns

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Email: simon.inns@gmail.com

************************************************************************/

// Global includes
#include <htc.h>

// Local includes
#include "hardware.h"
#include "interrupt.h"
#include "spi.h"

// Low priority interrupt procedure
void interrupt low_priority lpHandler(void)
{
	unsigned char rowCounter;

	// Is this timer0 interrupting?
	if (TMR0IF)
	{
		// Refresh the display

		// Disable A6276 output
		OE_LED = 1;
		LEDwrite(display.row[display.currentRow].byte2, display.row[display.currentRow].byte1);
		rowWrite(display.currentRow);
		
		// Enable the A6276 output
		OE_LED = 0;
		
		display.currentRow++;
		if (display.currentRow == 8) display.currentRow = 0;

		TMR0L = 106;	// Reset the timer0 counter
		TMR0IF = 0;	// Clear the timer0 interrupt flag
	}
}

// High priority interrupt procedure
void interrupt hpHandler(void)
{
	// Nothing to do here yet...
}