/************************************************************************
	lm35.c

    16x8 LED Display
    Copyright (C) 2009 Simon Inns

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Email: simon.inns@gmail.com

************************************************************************/

// Global includes
#include <htc.h>

// Local includes
#include "hardware.h"
#include "lm35.h"

unsigned char readTemperature(void)
{
	unsigned char temperature;
	int result;
	float temp;

	// Perform ADC on RA0 to read the LM35 voltage output
	GODONE = 1; 	// Start the ADC conversion
	while(GODONE);	// Wait for the ADC conversion to complete

	// Get the ADC result (1023 = +5v (5000 milliVolts)
	result = ADRESL;
	result += (ADRESH << 8);

	// Calculate the current temperature
	temp = (((5000 / 1023) * (float)result) / 10) + 2;

	// Return the temperature to the nearest degree C
	temperature = (unsigned char)temp;

	return (unsigned char)temperature;
}